Scriptname ImmersivedetectionofNPC extends Quest  

Actor Player
Actor randomActor
float va
float vb
float vc
float vd
float sa 
float sb
float dt
float Property norCnt Auto
float Property wawCnt Auto
Bool day
Bool night
Bool dawn
Bool dusk
Bool set
Bool norSet
Spell Property Candlelight Auto
Spell Property VampireVampirism Auto
Keyword Property Vampire Auto
Keyword Property ActorTypeGhost Auto
Keyword Property ActorTypeDwarven Auto
Keyword Property ActorTypeUndead Auto
Faction Property darkbrotherhoodfaction  Auto  
Race Property FalmerRace Auto
Race Property WolfRace Auto
Race Property BearSnowRace Auto
Race Property WerewolfBeastRace Auto
Race Property KhajiitRace Auto
Race Property SkeeverRace Auto
Race Property SkeeverWhiteRace Auto


float Function GetCurrentHourOfDay() global
{Returns the current time of day in hours since midnight}
 
	float Time = Utility.GetCurrentGameTime()
	Time -= Math.Floor(Time) ; Remove "previous in-game days passed" bit
	Time *= 24 ; Convert from fraction of a day to number of hours
	Return Time
 
EndFunction


;=========================== When and Where ==============================
Function whenAndWhere()
	Player = Game.GetPlayer()
	;Debug.notification("waw")
	If Player.IsInInterior()
		;inside()
		insideVanilla()
	else
		outside()
	EndIf
EndFunction
;=========================== When and Where ==============================

;=========================== Outside ========================================
Function outside()
	va = 0
	vb = 0
	vc = 0
	vd = 0
;---------------------------- DAY ---------------------------------
	If (GetCurrentHourOfDay() > 6 && GetCurrentHourOfDay() < 18)
		if !day
			;Debug.notification("It is getting lighter")
			day = true
			night = false
			dawn = false
			dusk = false
		endIf
		sa = 1.4
		sb = 0.4		
		checkWeather()
		;checkSneak()
		;Debug.notification("Outside day code(WAW)")
		;Game.SetGameSettingFloat("fSneakBaseValue", -15)
		Game.SetGameSettingFloat("fDetectionSneakLightMod", 100 - va)
		Game.SetGameSettingFloat("fSneakLightMoveMult", 1 - vb)
		Game.SetGameSettingFloat("fSneakLightRunMult", 2 - vc)
		Game.SetGameSettingFloat("fSneakLightMult", 1 - vd)
			
			
		Game.SetGameSettingFloat("fSneakRunningMult", sa)
		Game.SetGameSettingFloat("fSneakSoundsMult", sb)
		
		Game.SetGameSettingFloat("fSneakMaxDistance", 2800)
		Game.SetGameSettingFloat("fDetectionViewCone", 140)
;---------------------------- DAY ----------------------------------
;---------------------------- DAWN ---------------------------------
	elseIf	(GetCurrentHourOfDay() > 5 && GetCurrentHourOfDay() < 6)
		if !dawn
			;Debug.notification("Dawn is breaking")
			day = false
			night = false
			dawn = true
			dusk = false
		endIf
		sa = 1.5
		sb = 0.5
		dt = 0
		checkWeather()
		;checkSneak()
		;Debug.notification("Outside dawn code(WAW)")
		;Game.SetGameSettingFloat("fSneakBaseValue", -15)
		Game.SetGameSettingFloat("fDetectionSneakLightMod", 5 - va)
		Game.SetGameSettingFloat("fSneakLightMoveMult", 0.01 - vb)
		Game.SetGameSettingFloat("fSneakLightRunMult", 0.2 - vc)
		Game.SetGameSettingFloat("fSneakLightMult", 0.4 - vd)
			
			
		Game.SetGameSettingFloat("fSneakRunningMult", sa)
		Game.SetGameSettingFloat("fSneakSoundsMult", sb)
		
		Game.SetGameSettingFloat("fSneakMaxDistance", 2600 - dt)
		Game.SetGameSettingFloat("fDetectionViewCone", 130)
;---------------------------- DAWN ----------------------------------
;---------------------------- NIGHT ---------------------------------
	elseIf (GetCurrentHourOfDay() > 20 || GetCurrentHourOfDay() < 5)
		if 	!night
			;Debug.notification("Night falls")
			day = false
			night = true
			dawn = false
			dusk = false
		endIf
		sa = 1.5
		sb = 0.5
		dt = 0
		checkWeather()
		;checkSneak()
		;Debug.notification("Outside night code(WAW)")
		;Game.SetGameSettingFloat("fSneakBaseValue", -15)
		Game.SetGameSettingFloat("fDetectionSneakLightMod", 5 - va)
		Game.SetGameSettingFloat("fSneakLightMoveMult", 0.01 - vb)
		Game.SetGameSettingFloat("fSneakLightRunMult", 0.2 - vc)
		Game.SetGameSettingFloat("fSneakLightMult", 1 - vd)
			
			
		Game.SetGameSettingFloat("fSneakRunningMult", sa)
		Game.SetGameSettingFloat("fSneakSoundsMult", sb) 
		
		Game.SetGameSettingFloat("fSneakMaxDistance", 3000 - dt)
		Game.SetGameSettingFloat("fDetectionViewCone", 120)
;---------------------------- NIGHT ---------------------------------
;---------------------------- DUSK ----------------------------------
	elseIf (GetCurrentHourOfDay() > 18 && GetCurrentHourOfDay() < 20)
		if 	!dusk
			;Debug.notification("The sun drowned in the horizon")
			day = false
			night = false
			dawn = false
			dusk = true
		endIf
		sa = 1.4
		sb = 0.4
		checkWeather()
		;checkSneak()
		;Debug.notification("Outside dusk code(WAW)")
		;Game.SetGameSettingFloat("fSneakBaseValue", -15)
		Game.SetGameSettingFloat("fDetectionSneakLightMod", 15 - va)
		Game.SetGameSettingFloat("fSneakLightMoveMult", 1 - vb)
		Game.SetGameSettingFloat("fSneakLightRunMult", 2 - vc)
		Game.SetGameSettingFloat("fSneakLightMult", 0.5 - vd)
			
			
		Game.SetGameSettingFloat("fSneakRunningMult", sa)
		Game.SetGameSettingFloat("fSneakSoundsMult", sb) 
		
		Game.SetGameSettingFloat("fSneakMaxDistance", 2800)
		Game.SetGameSettingFloat("fDetectionViewCone", 130)
		
	endIf
;---------------------------- DUSK ----------------------------------
EndFunction	
;=========================== Outside ========================================

;=========================== Wheather system =============================
Function checkWeather()
	Weather currentWeather = Weather.GetCurrentWeather()
	if day
		if	currentWeather.GetClassification() == 2
			;Debug.Notification("DAY RAINING")
			va = 70
			vb = 0.01
			vc = 0.2
			vd = 0.4
		
			sa = 0.8
			sb = 0.2
		
		elseIf	currentWeather.GetClassification() == 3
			;Debug.Notification("DAY SNOWING")
			va = 80
			vb = 0.01
			vc = 0.2
			vd = 0
		
			sa = 0.9
			sb = 0.3
		endIf
	else
		if	currentWeather.GetClassification() == 2
			;Debug.Notification("RAINING")
			va = 4
			vb = 0.01
			vc = 0.2
			vd = 0.4
		
			sa = 0.8
			sb = 0.2
		
		elseIf	currentWeather.GetClassification() == 3
			;Debug.Notification("SNOWING")
			va = 5
			vb = 0.01
			vc = 0.2
			vd = 0
		
			sa = 0.9
			sb = 0.3
		endIf
	endIf
EndFunction
;=========================== Wheather system =============================

;=========================== Interior ====================================
Function inside()
	;Debug.notification("Inside code run")
	;Game.SetGameSettingFloat("fSneakBaseValue", -15)
	Game.SetGameSettingFloat("fDetectionSneakLightMod", 5)
	Game.SetGameSettingFloat("fSneakLightMoveMult", 0)
	Game.SetGameSettingFloat("fSneakLightRunMult", 0)
	Game.SetGameSettingFloat("fSneakLightMult", 1)
		
	Game.SetGameSettingFloat("fSneakRunningMult", 2)
	Game.SetGameSettingFloat("fSneakSoundsMult", 1)
		
	Game.SetGameSettingFloat("fSneakMaxDistance", 2500)
	Game.SetGameSettingFloat("fDetectionViewCone", 120)
EndFunction
;=========================== Interior ====================================

;=========================== Interior Vanilla setting ====================================
Function insideVanilla()
	;Debug.notification("Inside Vanilla code run")
	;Game.SetGameSettingFloat("fSneakBaseValue", -15)
	Game.SetGameSettingFloat("fDetectionSneakLightMod", 15)
	Game.SetGameSettingFloat("fSneakLightMoveMult", 0.01)
	Game.SetGameSettingFloat("fSneakLightRunMult", 0.2)
	Game.SetGameSettingFloat("fSneakLightMult", 0.33)
		
	Game.SetGameSettingFloat("fSneakRunningMult", 2)
	Game.SetGameSettingFloat("fSneakSoundsMult", 1)
		
	Game.SetGameSettingFloat("fSneakMaxDistance", 2500)
	Game.SetGameSettingFloat("fDetectionViewCone", 190)
EndFunction

;=========================== Interior Vanilla setting ====================================

;=========================== checkSneak ==================================
Function checkSneak()
	if	Player.IsSneaking()
		;Debug.notification("Sneaking")
		sa = 0
		sb = 0
		dt = 1500
	endIf
EndFunction
;=========================== checkSneak ==================================

;=========================== start =======================================
Function startIDNPC()
	while true
		if wawCnt > 5
			whenAndWhere()
			wawCnt = 0
		endIf
		checkNPC()
		wawCnt = wawCnt + 1
		Utility.Wait(1)
	endWhile
EndFunction
;=========================== start =======================================


Event OnInit()
	startIDNPC()
EndEvent


Function checkNPC()
	Player = Game.GetPlayer()
	if norCnt > 4 && !norSet
		Game.SetGameSettingFloat("fSneakBaseValue", -15)
		;debug.notification("SneakBaseValue = -15")
		norCnt = 0
		norSet = True
		set = false
	endIf
	randomActor = Game.FindRandomActorFromRef(Player, 2000.0)
	if randomActor != Player && !randomActor.IsInInterior()
		checkDetector()
	else
		norCnt = norCnt + 1
	endIf
EndFunction

Function checkDetector()
If	!randomActor.IsDead()
;---------------------------- DAY ---------------------------------
	If (GetCurrentHourOfDay() > 6 && GetCurrentHourOfDay() < 20)
		if detectBySmell(randomActor) && !set
			randomActor.CreateDetectionEvent(Player,100)
			;debug.notification("SneakBaseValue = 15(outside day)")
			;Candlelight.cast(randomActor,randomActor)
			Game.SetGameSettingFloat("fSneakBaseValue", 15)
			
			set = True
			norSet = false
			norCnt = 0
		else
			norCnt = norCnt + 1	
		EndIf
;---------------------------- DAY ----------------------------------
;---------------------------- NIGHT ---------------------------------
	else
		if  actorIsSpecial(randomActor) || detectBySkill(randomActor)
			if !set
				randomActor.CreateDetectionEvent(Player,100)
				;debug.notification("SneakBaseValue = 15(outside night)")
				;Candlelight.cast(randomActor,randomActor)
				Game.SetGameSettingFloat("fSneakBaseValue", 15)
				
				set = True
				norSet = false
				norCnt = 0
			endIf
		else
			norCnt = norCnt + 1
		EndIf
	endIf
;---------------------------- NIGHT ---------------------------------
else
	norCnt = norCnt + 1
EndIf
EndFunction	

;====================================================================================
Bool Function detectBySmell (Actor xActor)
	If  xActor.GetRace () == FalmerRace || xActor.GetRace () == WolfRace || xActor.GetRace () == BearSnowRace || xActor.GetRace () == WerewolfBeastRace
		Return True
	EndIf
	Return False
EndFunction

Bool Function detectByHeat (Actor xActor)
	If xActor.HasSpell (VampireVampirism) || xActor.HasKeyWord (Vampire) || xActor.HasKeyWord (ActorTypeGhost) ||  xActor.HasKeyWord (ActorTypeDwarven) || xActor.HasKeyWord (ActorTypeUndead)
		Return True
	EndIf
	Return False
EndFunction

Bool Function detectBySkill (Actor xActor)
	If  xActor.GetRace () == KhajiitRace || xActor.GetRace () == SkeeverRace || xActor.GetRace () == SkeeverWhiteRace ||  xActor.HasKeyWord (ActorTypeDwarven) ||  xActor.IsInFaction(darkbrotherhoodfaction)
		Return True
	EndIf
	Return False
EndFunction

Bool Function actorIsSpecial(Actor xActor)
	if detectBySmell(xActor) || detectByHeat(xActor)
		Return True
	EndIf
	Return False
EndFunction
;=======================================================================================
